#include <math.h>
#include "util.h"
#define PI      3.14159265358979324  
#define LOG_2PI 1.83787706640934548 
#define N       8

#define B0  1                 
#define B1  (-1.0 / 2.0)
#define B2  ( 1.0 / 6.0)
#define B4  (-1.0 / 30.0)
#define B6  ( 1.0 / 42.0)
#define B8  (-1.0 / 30.0)
#define B10 ( 5.0 / 66.0)
#define B12 (-691.0 / 2730.0)
#define B14 ( 7.0 / 6.0)
#define B16 (-3617.0 / 510.0)



void lmgamma(double* x, double* y, int n){
	int i;
	for(i=0; i<n; i++){
		y[i] = lgamma(x[i]);
	}
}



double lgamma(double x) 
{
    double v, w;

    v = 1;
    while (x < N) {  v *= x;  x++;  }
    w = 1 / (x * x);
    return ((((((((B16 / (16 * 15))  * w + (B14 / (14 * 13))) * w
                + (B12 / (12 * 11))) * w + (B10 / (10 *  9))) * w
                + (B8  / ( 8 *  7))) * w + (B6  / ( 6 *  5))) * w
                + (B4  / ( 4 *  3))) * w + (B2  / ( 2 *  1))) / x
                + 0.5 * LOG_2PI - log(v) - x + (x - 0.5) * log(x);
}

double gamma(double x) 
{
    if (x < 0)
        return PI / (sin(PI * x) * exp(lgamma(1 - x)));
    return exp(lgamma(x));
}

double beta(double x, double y)  
{
    return exp(lgamma(x) + lgamma(y) - lgamma(x + y));
}


