// 2011.09.08: Header is included from util.h.
//#include <stdio.h>
//#include <math.h>
//#include <stdlib.h>
//#include "mkl_cblas.h"
//#include "mkl_lapack.h"

#include "util.h"
#define ITMAX 500


double prior = 1.0;



double delta;
double lambda;

/*
# status = 0: converged
# status = 4: not converged
*/
void GMM(double* X, double* w, int N, double* Mu, double* Sigma, double* Theta, double* Theta15, double* Theta21, double* Z15, double* Z21, double* d, double* lkhd, int* status){
	int i;
	
	double* plk;
	
	double nn = cblas_dasum(N, w, 1);
	
	delta = ((double) nn)*delta0;
	lambda = ((double) nn)*lambda0*10.0;
	cblas_dcopy(K*4, Sigma0, 1, Sigma, 1);
	cblas_dcopy(K*2, Mu0, 1, Mu, 1);
	
	for(i=0; i<2*K; i++){m[i] = log(Mu0[i])+0.0*S[i]/delta;}
	cblas_dcopy(N*2, X, 1, X1, 1);
	for(i=0; i<N*2; i++){  if( isnan(X[i])>0 ){ X1[i]=0.0; }  }
	plk = lk;
	(*status)=4;
	/*
	vprint(X, 10);
	vprint(w, 10);
	vprint(Mu, 30);
	vprint(Sigma, 60);
	vprint(Theta, J);
	*/
	
	for(i=0; i<ITMAX; i++){
		Estep(X, w, N, Mu, Sigma, Theta, Z15, Z21, d, plk);
		if(isnan(lk[i])){break;}
		if(i > 10){
			if(fabs(lk[i]-lk[i-1])<1.0e-8){(*lkhd) = lk[i]; (*status) = 0; break;}
		}
		Mstep(X1, w, N, Z15, Z21, Theta, Theta15, Theta21, Mu, Sigma);
		plk++;
		//printf("%d %lf\n",i,lk[i]);
	}
	(*lkhd) = lk[ITMAX-1];
}

/*
##########################
#  M STEP
#  Z21 -> Theta
#  Z21 -> theta21 -> Theta15
#  Z15,w -> ng
#  Z15,X1,w -> ngxb
##########################
*/
void Mstep(double* X1, double* w, int N, double* Z15, double* Z21, double* Theta, double* Theta15, double* Theta21, double* Mu, double* Sigma){
	int i,j,k,itr;
	int M=2*K;
	
	// Theta21
	cblas_dgemv(CblasColMajor, CblasTrans, N, J*(J+1)/2, 1.0, Z21, N, w, 1, 0.0, Theta21, 1);
	// Theta15 and Theta
	clear(Theta, J);
	clear(Theta15, K);
	int l=0;
	for(i=0; i<J; i++){ 
		for(j=i; j<J; j++){
			int na = a[i]+a[j];
			int nb = b[i]+b[j];
			Theta15[cs[na+nb*5]] += Theta21[l];
			if(i==j){
				Theta[i] += Theta21[l];
			}else{  
				Theta[i] += Theta21[l]/2.0;
				Theta[j] += Theta21[l]/2.0;
			}
			l++;
		}
	}
	double tot = cblas_dasum(J, Theta, 1);
	for(i=0; i<J; i++){ 
		Theta[i] += alpha[i]-1.0; 
		Theta[i] /= (tot+alpha0-((double)J)); 
		if(Theta[i]<0.0){Theta[i]=0.0;}
	}
	tot = cblas_dasum(J, Theta, 1);
	cblas_dscal(J, 1.0/tot, Theta, 1);
	tot = cblas_dasum(K, Theta15, 1);
	cblas_dscal(K, 1.0/tot, Theta15, 1);
	
	// Mu and Sigma  *********** Z15 destroied *****************
	
	for(i=0; i<N; i++){for(k=0; k<K; k++){ Z15[i+k*N] *= w[i]; }}
	cblas_dgemv(CblasColMajor, CblasTrans, N, K, 1.0, Z15, N, uvn, 1, 0.0, ng, 1);
	cblas_dgemm(CblasColMajor, CblasNoTrans, CblasNoTrans, 2, K, N, 1.0, X1, 2, Z15, N, 0.0, ngxb, 2);
	
	
	for(i=0; i<M; i++){ Nu[i] = Nu0[i] = log(Mu[i]); } // Nu = log(Mu)
	
	
// 2011.09.08: To support atlas.
	//int INFO; char UPLO = 'U'; int LDA = M; int LDB = M; int NRHS = 1;// CBLAS_UPLO uplo = CblasUpper;
	int INFO; int LDA = M; int LDB = M; int NRHS = 1;// CBLAS_UPLO uplo = CblasUpper;
#ifdef USEMKL
	char UPLO = 'U';
#elif USEATLAS
	enum ATLAS_ORDER order = CblasColMajor;
	enum ATLAS_UPLO uplo = CblasUpper;
#else
#error Unsupported Library is specified. Supported library is InteMKL(USEMKL) or Atlas(USEATLAS).
#endif
	
	clear(hess,M*M);
		
	
	clear(SigmaInv,4*K);
	for(i=0; i<K; i++){inverse(Sigma+4*i,SigmaInv+4*i);}
	
	
	double d2; 
	double ngxbmMu[2];
	double Numm[M];
	clear(hessTemp,M*M);
	for(itr=0; itr<100; itr++){
		clear(grad,M);
		cblas_dcopy(M*M, Sinv, 1, hess, 1);
		cblas_dscal(M*M, delta, hess, 1);
		
		for(i=0; i<K; i++){
			ngxbmMu[0] = ngxb[i*2]  -ng[i]*Mu[i*2];
			ngxbmMu[1] = ngxb[i*2+1]-ng[i]*Mu[i*2+1]; 
			grad[i*2]  = Mu[i*2]*(SigmaInv[i*4+0]*ngxbmMu[0]+SigmaInv[i*4+2]*ngxbmMu[1]);
			grad[i*2+1]= Mu[i*2+1]*(SigmaInv[i*4+1]*ngxbmMu[0]+SigmaInv[i*4+3]*ngxbmMu[1]);
		}
		for(i=0; i<K; i++){
			hess[(M+1)*i*2]       += ng[i]*(Mu[i*2]*Mu[i*2]*SigmaInv[i*4+0])-grad[i*2]; 
			hess[(M+1)*(i*2+1)-1] += ng[i]* Mu[i*2+1]*Mu[i*2]*SigmaInv[i*4+2];
			hess[(M+1)*i*2+1]     += ng[i]* Mu[i*2+1]*Mu[i*2]*SigmaInv[i*4+1];          
			hess[(M+1)*(i*2+1)]   += ng[i]*(Mu[i*2+1]*Mu[i*2+1]*SigmaInv[i*4+3])-grad[i*2+1];
		}
		cblas_dcopy(M*M, hess, 1, hessTemp, 1);
// 2011.09.08: To support atlas.
#ifdef USEMKL
		dpotrf_(&UPLO, &M, hess, &LDA, &INFO );
#elif USEATLAS
		INFO = clapack_dpotrf(order, uplo, M, hess, LDA);
#else
#error Unsupported Library is specified. Supported library is InteMKL(USEMKL) or Atlas(USEATLAS).
#endif
		if(INFO!=0){
			cblas_dcopy(M*M, hessTemp, 1, hess, 1);
			for(i=0; i<K; i++){
				hess[(M+1)*i*2]       += grad[i*2]; 
				hess[(M+1)*(i*2+1)]   += grad[i*2+1];
			}
// 2011.09.08: To support atlas.
#ifdef USEMKL
			dpotrf_(&UPLO, &M, hess, &LDA, &INFO );
#elif USEATLAS
			INFO = clapack_dpotrf(order, uplo, M, hess, LDA);
#else
#error Unsupported Library is specified. Supported library is InteMKL(USEMKL) or Atlas(USEATLAS).
#endif
			if(INFO>0){printf("\tinfo=%d",INFO); for(i=0; i<M; i++){Mu[i] = exp(Nu[i])/1.01;}; break;}
		}
		
		
		cblas_dcopy(M, Nu, 1, Numm, 1);    // copy Nu
		cblas_daxpy(M, -1.0, m, 1, Numm, 1);      // Nu-m
		cblas_dsymv(CblasColMajor, CblasUpper, M, -1.0*delta, Sinv, M, Numm, 1, 1.0, grad, 1); // g += -S^-1(Nu-m)
		for(i=0; i<M; i++){grad[i] -= 1.0;}     // g -= 1
		d2 = cblas_dasum(M, grad, 1);
// 2011.09.08: To support atlas.
#ifdef USEMKL
		dpotrs_(&UPLO, &M, &NRHS, hess, &LDA, grad, &LDB, &INFO );
#elif USEATLAS
		INFO = clapack_dpotrs(order, uplo, M, NRHS, hess, LDA, grad, LDB);
#else
#error Unsupported Library is specified. Supported library is InteMKL(USEMKL) or Atlas(USEATLAS).
#endif
		if(INFO!=0)printf("\tinfo=%d",INFO);
		cblas_daxpy(M, 1.0, grad, 1, Nu, 1);
		
		for(i=0; i<M; i++){Mu[i] = exp(Nu[i]); };
		if(itr>2 && (d2)<1e-8){break;}else{cblas_dcopy(M, Nu, 1, Nu0, 1);}// Termination
	}
	cblas_dcopy(K*4, Sigma0, 1, Sigma, 1);
	double px = (cblas_dasum(K, Mu, 2))/(cblas_dasum(K, Mu0, 2));
	double py = (cblas_dasum(K, Mu+1, 2))/(cblas_dasum(K, Mu0+1, 2));
	cblas_dscal(K, lambda*px*px, Sigma+0, 4);
	cblas_dscal(K, lambda*px*py, Sigma+1, 4);
	cblas_dscal(K, lambda*py*px, Sigma+2, 4);
	cblas_dscal(K, lambda*py*py, Sigma+3, 4);
	for(j=0; j<K; j++){
		cblas_dcopy(N*2, X1, 1, X2, 1);
		cblas_daxpy(N, -Mu[j*2], uvn, 1, X2, 2); 
		cblas_daxpy(N, -Mu[j*2+1], uvn, 1, X2+1, 2);
		cblas_dcopy(N*2, X2, 1, X3, 1);
		for(i=0; i<N; i++){
			X2[i*2]   *= (Z15[j*N+i]); 
			X2[i*2+1] *= (Z15[j*N+i]);
		}
		cblas_dgemm(CblasColMajor, CblasNoTrans, CblasTrans, 2, 2, N, 1.0, X2, 2, X3, 2, 1.0, Sigma+j*4, 2);
		cblas_dscal(4, 1.0/(ng[j]+lambda), Sigma+j*4, 1);
	}
}

/*
##########################
#  E STEP
##########################
*/
void Estep(double* X, double* w, int N, double* Mu, double* Sigma, double* Theta, double* Z15, double* Z21, double* d, double* lk){
	double lkhd = 0.0;
	int i,j,k,l;
	clear(Z15, N*K);
	clear(Z21, N*J*(J+1)/2);
	
	// p(G|Z) -> Z15
	for(k=0; k<K; k++){
		mvdnorm(X, N, Mu+2*k, Sigma+4*k, Z15+N*k);
	}
//vprint(Z15+N*2,10);
	// p(Z)p(G|Z) -> Z21
	l=0;
	for(i=0; i<J; i++){
		for(j=i; j<J; j++){
			int na = a[i]+a[j];
			int nb = b[i]+b[j];
			if(i==j){
				cblas_dcopy(N, Z15+(cs[na+nb*5])*N, 1, Z21+l*N, 1);
				cblas_dscal(N, Theta[i]*Theta[j], Z21+l*N, 1);
			}else{
				cblas_dcopy(N, Z15+(cs[na+nb*5])*N, 1, Z21+l*N, 1);
				cblas_dscal(N, 2.0*Theta[i]*Theta[j], Z21+l*N, 1);
			}
			l++;
		}
	}
	// d = sum_Z[ p(Z)p(G|Z) ]
	cblas_dgemv(CblasColMajor, CblasNoTrans, N, J*(J+1)/2, 1.0, Z21, N, uvj, 1, 0.0, d, 1);
	// Z21
	for(i=0; i<N; i++){
		if(d[i]>0.0){
			lkhd += w[i]*log(d[i]);
			cblas_dscal(J*(J+1)/2, 1.0/d[i], Z21+i, N);
		}else{
			cblas_dscal(J*(J+1)/2, 0.0, Z21+i, N); 
		}
	}
	// Z15
	clear(Z15, N*K);
	l=0;
	for(i=0; i<J; i++){ 
		for(j=i; j<J; j++){
			int na = a[i]+a[j];
			int nb = b[i]+b[j];
			cblas_daxpy(N, 1.0, Z21+l*N, 1, Z15+(cs[na+nb*5])*N, 1); 
			l++;
		}
	}
	
	// Penalized Likelihood
	int M=K*2;
	double Numm[M];
	double Nu[M];
	double grad[M];
	for(i=0; i<M; i++){Nu[i] = log(Mu[i]);}
	cblas_dcopy(M, Nu, 1, Numm, 1);		   // Nu
	cblas_daxpy(M, -1.0, m, 1, Numm, 1);	  // Nu-m
	cblas_dsymv(CblasColMajor, CblasUpper, M, 1.0, Sinv, M, Numm, 1, 0.0, grad, 1); // g = -S^-1(Nu-m) 
	for(i=0; i<K; i++){ lkhd -= prior*Nu[i];}
	for(i=0; i<M; i++){ lkhd -= 0.5*prior*grad[i]*Numm[i]; }
	for(i=0; i<K; i++){ 
		double SigmaI[4];
		inverse(Sigma+i*4, SigmaI);
		lkhd -= 0.5*lambda*prior*(log(det(Sigma+i*4))
			+Sigma0[i*4]*SigmaI[0]+Sigma0[i*4+1]*SigmaI[1]
			+Sigma0[i*4+2]*SigmaI[2]+Sigma0[i*4+3]*SigmaI[3]);
	}
	
	(*lk) = lkhd;
	
}







void table(int* x, int N, int* t, double* w, int* Nw){
	int i,k,flag;
	clear(w, N);
	t[0]=x[0];
	w[0]=1.0;
	//vprintInt(x, 10, 0);
	//vprintInt(t, 10, 0);
	(*Nw)=1;
	for(i=1; i<N; i++){
		flag=0;
		for(k=0; k<(*Nw); k++){
			if(x[i]==t[k]){w[k]++; flag=1; break;}
		}
		if(flag==0){t[(*Nw)]=x[i]; w[(*Nw)]=1.0; (*Nw)=(*Nw)+1;}
		//vprintInt(t, (*Nw), 0);
		//printf("%d %d %d\n", x[i], flag, (*Nw));
	}
}







double getErrorRate(double* Z15, double* Theta15, double* w, int Nw){
	int i,j,k;
	double covmat[K*K];
	clear(covmat,K*K); 
	double err=0.0; 
	double n=0.0;
	for(i=0; i<Nw; i++){
		for(j=0; j<K; j++){for(k=0; k<K; k++){
			covmat[j+K*k] += Z15[i+j*Nw]*Z15[i+k*Nw]*w[i];
		}}
		n+=w[i];
	}
	for(j=0; j<K; j++){for(k=0; k<K; k++){ 
		covmat[j+K*k] /= n;
		covmat[j+K*k] -= Theta15[j]*Theta15[k]; 
		err -= covmat[j+K*k]*((double)(K-2));
	}}
	for(j=0; j<K; j++){
	    err += Theta15[j]*(1-Theta15[j]);
	    err -= covmat[j+j*K];
	}
	return err/2.0;
}




void getZ6(double* Z6, double* Z21){
	int i, j, l;
	clear(Z6,N*J);
	l=0;
	for(i=0; i<J; i++){
			 for(j=i; j<J; j++){
				    if(i==j){
				    	cblas_daxpy(N, 2.0, Z21+l*N, 1, Z6+i*N, 1);
			}else{
				    	cblas_daxpy(N, 1.0, Z21+l*N, 1, Z6+i*N, 1);
				    	cblas_daxpy(N, 1.0, Z21+l*N, 1, Z6+j*N, 1);
			}
				    l++;
			 }
	   }
}


void setAVar(double* X, double* Z21, double* Z15, double* Z6, double* Theta, double* Mu, double* Sigma, double* cjg, double* dig, double nep, double* avar){

	delta = ((double) N)*delta0;
	lambda = ((double) N)*lambda0*10.0;
	
	int M=K*2;
	int A=(J-1+K*5);
// 2011.09.08: Comment out unused local variable Nu.
	//double Nu[M];
// 2011.09.08: Comment out unused variable Numm.
	//double Numm[M];
	double SigmaInv[K*4];
	double Gamma[K*3];
	double grad[M];

	int i,j,k,l,m;
	clear(grad,M);
	clear(avar,A*A);
	
	double X1[N*2];
	cblas_dcopy(N*2, X, 1, X1, 1);
        for(i=0; i<N*2; i++){  if( isnan(X[i])>0 ){ X1[i]=0.0; }  };
	
	for(i=0; i<K; i++){inverse(Sigma+4*i,SigmaInv+4*i);}
	for(i=0; i<K; i++){chol(SigmaInv+4*i,Gamma+3*i);}
	
	//Z
	for(j=0; j<J-1; j++){
		for(k=j; k<J-1; k++){
			if(j==k){
				avar[A*k+j] += (2.0*nep+alpha0)*Theta[j];//hess
				for(i=0; i<N; i++){
					avar[A*k+j] -= Z6[j*N+i];//score
				}
			}
			avar[A*k+j] -= (2.0*nep+alpha0)*Theta[j]*Theta[k];//hess
			for(i=0; i<N; i++){
				avar[A*k+j] += 0.5*Z6[j*N+i]*Z6[k*N+i];//score
			}
		}
	}
	
	
	//cjg
	clear(cjg,N*K*5);
	for(k=0; k<K; k++){// cluster g
		for(i=0; i<N; i++){// sample
			for(m=0; m<J-1; m++){ // haplotype 1..5
				cjg[i+k*(J-1)*N+m*N] -= Z15[i+k*N]*Z6[i+m*N];
			}
		}
	}
	l=0;
	for(k=0; k<J; k++){for(j=k; j<J; j++){//hap pair J*(J+1)
		int na = a[k]+a[j];
		int nb = b[k]+b[j];
		int g = cs[na+nb*5];
		if(j<J-1){
			for(i=0; i<N; i++){
				cjg[i+g*(J-1)*N+j*N] += Z21[i+l*N];
			}
		}
		if(k<J-1){
			for(i=0; i<N; i++){
				cjg[i+g*(J-1)*N+k*N] += Z21[i+l*N];
			}
		}
		l++;
	}}
	
	//dig
	double ximmug[3];
	for(j=0; j<K; j++){
		for(i=0; i<N; i++){
			ximmug[0] = X1[i*2]-Mu[j*2];
			ximmug[1] = X1[i*2+1]-Mu[j*2+1];
			ximmug[2] = ximmug[0]*ximmug[1];
			dig[i+j*5*N] =     Mu[j*2]*(SigmaInv[4*j]  *ximmug[0] + SigmaInv[4*j+2]*ximmug[1]);
			dig[i+j*5*N+N] = Mu[j*2+1]*(SigmaInv[4*j+1]*ximmug[0] + SigmaInv[4*j+3]*ximmug[1]);
			ximmug[0] *= (X1[i*2]-Mu[j*2]);
			ximmug[1] *= (X1[i*2+1]-Mu[j*2+1]);
			dig[i+j*5*N+N*2] = 1.0/Gamma[j*3]  -ximmug[0]*Gamma[j*3] -ximmug[2]*Gamma[j*3+1];
			dig[i+j*5*N+N*3] =                 -ximmug[2]*Gamma[j*3] -ximmug[1]*Gamma[j*3+1];
			dig[i+j*5*N+N*4] = 1.0/Gamma[j*3+2]-ximmug[1]*Gamma[j*3+2];
		}
	}
	
	//Hg\xi
	for(k=0; k<K; k++){// between cluster (yoko)
		for(m=0; m<5; m++){// within cluster (yoko)
			for(j=0; j<(J-1); j++){// xi (tate)
				for(i=0; i<N; i++){// subject
					avar[(J-1)*A+A*5*k+A*m+j] -= cjg[i+N*(J-1)*k+N*j]*dig[i+N*5*k+N*m];
				}
			}
		}
	}
	
	//cblas_dgemm(CblasColMajor, CblasTrans, CblasNoTrans, K*5, K*5, N...
	for(j=0; j<K; j++){// between cluster (tate)
		for(k=j; k<K; k++){// between cluster (yoko)
			for(l=0; l<5; l++){// xi   tate
				for(m=0; m<5; m++){// xi  yoko
					if(j==k){
						for(i=0; i<N; i++){// subject
							avar[(J-1)*A+(J-1)+A*5*k+5*j+m*A+l] -= Z15[i+k*N]*(1.0-Z15[i+j*N])*dig[i+N*5*j+N*l]*dig[i+N*5*k+N*m];
						}
					}else{
						for(i=0; i<N; i++){// subject
							avar[(J-1)*A+(J-1)+A*5*k+5*j+m*A+l] += Z15[i+k*N]*Z15[i+j*N]*dig[i+N*5*j+N*l]*dig[i+N*5*k+N*m];
						}
					}
				}
			}
		}
	}
	
	
	for(i=0; i<M; i++){Nu[i] = log(Mu[i]);}
	
	// prior for nu
	for(i=0; i<K; i++){
		for(j=i; j<K; j++){
			avar[(J-1)*A+J-1+5*A*j+5*i]     += delta*Sinv[2*M*j+2*i] ;
			avar[(J-1)*A+J-1+5*A*j+5*i+1]   += delta*Sinv[2*M*j+2*i+1];
			avar[(J-1)*A+J-1+5*A*j+5*i+A]   += delta*Sinv[2*M*j+2*i+M];
			avar[(J-1)*A+J-1+5*A*j+5*i+A+1] += delta*Sinv[2*M*j+2*i+M+1];
		}
	}
	// complete hess for nu and sigma
	double ng[K];
	double ngxb[M];
	double ngxbmMu[2];
        cblas_dgemv(CblasColMajor, CblasTrans, N, K, 1.0, Z15, N, uvn, 1, 0.0, ng, 1);
	cblas_dgemm(CblasColMajor, CblasNoTrans, CblasNoTrans, 2, K, N, 1.0, X1, 2, Z15, N, 0.0, ngxb,2);
	for(i=0; i<K; i++){
		ngxbmMu[0] = ngxb[i*2]  -ng[i]*Mu[i*2];
		ngxbmMu[1] = ngxb[i*2+1]-ng[i]*Mu[i*2+1];
		grad[i*2]  = Mu[i*2]*(SigmaInv[i*4+0]*ngxbmMu[0]+SigmaInv[i*4+2]*ngxbmMu[1]);
		grad[i*2+1]= Mu[i*2+1]*(SigmaInv[i*4+1]*ngxbmMu[0]+SigmaInv[i*4+3]*ngxbmMu[1]);
		
		avar[(J-1)*A+J-1+5*A*i+5*i]     += ng[i]*(Mu[i*2]  *Mu[i*2]  *SigmaInv[i*4+0])-grad[i*2];
	//avar[(J-1)*A+J-1+5*A*i+5*i+1]   += ng[i]* Mu[i*2+1]*Mu[i*2]  *SigmaInv[i*4+1];
		avar[(J-1)*A+J-1+5*A*i+5*i+A]   += ng[i]* Mu[i*2+1]*Mu[i*2]  *SigmaInv[i*4+2];
		avar[(J-1)*A+J-1+5*A*i+5*i+A+1] += ng[i]*(Mu[i*2+1]*Mu[i*2+1]*SigmaInv[i*4+3])-grad[i*2+1];
		
		avar[(J-1)*A+J-1+5*A*i+5*i+2*A]   += -Mu[i*2]*(2.0*Gamma[i*3]*ngxbmMu[0]+Gamma[i*3+1]*ngxbmMu[1]);
		avar[(J-1)*A+J-1+5*A*i+5*i+3*A]   += -Mu[i*2]*Gamma[i*3]*ngxbmMu[1];
		avar[(J-1)*A+J-1+5*A*i+5*i+2*A+1] += -Mu[i*2+1]*Gamma[i*3+1]*ngxbmMu[0];
		avar[(J-1)*A+J-1+5*A*i+5*i+3*A+1] += -Mu[i*2+1]*(Gamma[i*3]*ngxbmMu[0]+2.0*Gamma[i*3+1]*ngxbmMu[1]);
		avar[(J-1)*A+J-1+5*A*i+5*i+4*A+1] += -Mu[i*2+1]*2.0*Gamma[i*3+2]*ngxbmMu[1];
		
		avar[(J-1)*A+J-1+5*A*i+5*i+2*A+2] += (ng[i]+lambda)*(1.0/Power(Gamma[i*3],2)+Sigma[i*4]);
	//avar[(J-1)*A+J-1+5*A*i+5*i+2*A+3] += (ng[i]+lambda)*Sigma[i*4+1];
		avar[(J-1)*A+J-1+5*A*i+5*i+3*A+2] += (ng[i]+lambda)*Sigma[i*4+2];
		avar[(J-1)*A+J-1+5*A*i+5*i+3*A+3] += (ng[i]+lambda)*Sigma[i*4+3];
		avar[(J-1)*A+J-1+5*A*i+5*i+4*A+4] += (ng[i]+lambda)*(1.0/Power(Gamma[i*3+2],2)+Sigma[i*4+3]);
	}
}



int mvdnorm(double* X, int N, double* Mu, double* Sigma, double* z){
	int i;
	
	double Inv[4];
	inverse(Sigma, Inv);
	double sdet;
	sdet = sqrt(det(Sigma));
	double X1[N*2];
	double Y[N*2];
	cblas_dcopy(2*N, X, 1, X1, 1);
	cblas_daxpy(N, -Mu[0], uvn, 1, X1, 2);
	cblas_daxpy(N, -Mu[1], uvn, 1, X1+1, 2);
	
// 2011.09.08: To support atlas.
#ifdef USEMKL
	CBLAS_ORDER order = CblasColMajor;
	CBLAS_TRANSPOSE transx = CblasNoTrans;
	CBLAS_TRANSPOSE transy = CblasNoTrans;
#else /* USEATLAS */
	enum CBLAS_ORDER order = CblasColMajor;
	enum CBLAS_TRANSPOSE transx = CblasNoTrans;
	enum CBLAS_TRANSPOSE transy = CblasNoTrans;
#endif
	cblas_dgemm(order,transx,transy, 2, N, 2, -0.5, Inv, 2, X1, 2, 0.0, Y, 2);
	
	for(i=0; i<N; i++){ 
		if(isnan(X[i*2])==0&&isnan(X[i*2+1])==0){
			z[i] = exp(cblas_ddot(2, X1+2*i, 1, Y+2*i, 1))/2.0/M_PI/sdet; 
		}else{z[i] = 0.0;}
	}
	return 0;
}



double Power(double x, int n){
	int i;
	double res = 1;
	if(n<0){
		for(i=0; i<(-n); i++){
			res /= x;
		}
	}else{
		for(i=0; i<n; i++){
			res *= x;
		}
	}
	return res;
}

int isna(double* v, int N){
	int i;
	int res=0;
	for(i=0;i<N;i++){if(isnan(v[i])>0||v[i]<0){res++;}}
	return res;
}

int chol(double* A, double* L){
	L[0] = sqrt(A[0]);
	L[1] = A[1]/sqrt(A[0]);
	L[2] = sqrt(A[3]-A[2]*A[2]/A[0]);
	return 0;
}



int inverse(double* mat, double* inv){
	double dets;
	dets = det(mat);
	inv[0] = mat[3]/dets;
	inv[1] = -mat[1]/dets;
	inv[2] = -mat[2]/dets;
	inv[3] = mat[0]/dets;
	return 0;
}

double det(double* mat){
	return mat[0]*mat[3]-mat[1]*mat[2];
}

void clear(double* v, int N){
	//cblas_dscal(N, 0.0, v, 1);
	int i;
	#ifdef _OPENMP
		#pragma omp parallel for schedule (dynamic) private(i)
		#endif
	for(i=0; i<N; i++){v[i]=0.0;}
}


void clearInt(int* v, int N){
	//cblas_dscal(N, 0.0, v, 1);
	int i;
	#ifdef _OPENMP
		#pragma omp parallel for schedule (dynamic) private(i)
		#endif
	for(i=0; i<N; i++){v[i]=0;}
}


double DKL(double* m0, double* m1, double* s0, double* s1){
	double s1inv[4];
	double temp[2];
	double temp2[4];
	double dkl;
	
	inverse(s1,s1inv);
	cblas_dcopy(2, m0, 1, temp, 1);
	cblas_daxpy(2, -1.0, m1, 1, temp, 1);
// 2011.09.08: To support atlas.
#ifdef USEMKL
	CBLAS_ORDER order = CblasColMajor;
	CBLAS_TRANSPOSE transa = CblasNoTrans;
	CBLAS_TRANSPOSE transb = CblasNoTrans;
#else /* USEATLAS */
	enum CBLAS_ORDER order = CblasColMajor;
	enum CBLAS_TRANSPOSE transa = CblasNoTrans;
	enum CBLAS_TRANSPOSE transb = CblasNoTrans;
#endif

	cblas_dgemm(order, transa, transb, 2,2,2, 1.0, s1inv, 2, s0, 2, 0.0, temp2, 2);
	
	dkl = (log(det(s1))-log(det(s0))+temp2[0]+temp2[3]+quad(s1inv,temp)-2.0)/2.0;
	//printf("%lf\n",dkl);
	return dkl;
}
double EP(double* m0, double* m1, double* s0){
		double s1inv[4];
		double temp[2];
		inverse(s0,s1inv);
		diff(m0,m1,temp);
		return exp(-quad(s1inv,temp)/2.0);
}
int diff(double* x, double* y, double* z){
		z[0] = x[0]-y[0];
		z[1] = x[1]-y[1];
		return 0;
}


double quad(double* mat, double* vec){
		int i, j;
		double res = 0.0;
		for(i=0; i<2; i++){
				for(j=0; j<2; j++){
						res += vec[i]*vec[j]*mat[j+i*2];
				}
		}
		return res;
}	   


void trans(double* x, int n, double rho){
	int i;
	for(i=0; i<n; i++){
		if(x[i*2]>x[i*2+1]){
			x[i*2] = ((1-rho)*x[i*2]+rho*x[i*2+1])/(1-rho);
			x[i*2+1] = x[i*2+1]/(1-rho);	
		}else{
			x[i*2+1] = ((1-rho)*x[i*2+1]+rho*x[i*2])/(1-rho); 
						x[i*2] = x[i*2]/(1-rho);
		}
	}
}
void mprint(double* v, int n){
	int i,j;
	for(i=0; i<n; i++){
		for(j=0; j<n; j++){
					printf("%lf ",v[i+j*n]);	   
		}				  
		printf("\n");											
		}

}


void vprintInt(int* v, int n, int offset){
        int i=0;
        for(i=0+offset; i<n+offset; i++){
                printf("%d",v[i]);
                //if(v[i]>0.0){printf("!");}
                printf(" ");
        }
        printf("\n");
}


void vprint(double* v, int n){
	int i=0;
	for(i=0; i<n; i++){
		printf("%lf",v[i]);
		//if(v[i]>0.0){printf("!");}
		printf(",");
	}
	printf("\n");
}

void viprint(int* v, int n){
		int i=0;
		for(i=0; i<n; i++){
				printf("%d ",v[i]);
		}
		printf("\n");
}

double min(int n, double* v, int k){
     int i, ind=-1;
     double temp = 1e300;
     for(i=0; i<n; i++){
         if(isnan(v[i*k])==0){if(v[i*k] < temp){
              ind = i;
              temp = v[i*k];
         }}
     }
     if(ind<0){return log(-1.0);}else{
         return v[ind*k];
     }
}

double min0(double* v, int n){//more than 0.0
     int i, ind=-1;
     double temp = 1.1;
     for(i=0; i<n; i++){
         if(isnan(v[i])==0){if(v[i] < temp && v[i]>0.0){
              ind = i;
              temp = v[i];
         }}
     }
     if(ind<0){return log(-1.0);}else{
         return v[ind];
     }
}


double max(double* v, int n){
		int i, ind=-1;
		double temp = -1e300;
		for(i=0; i<n; i++){
				if(isnan(v[i])==0){if(v[i] > temp){
						ind = i;
						temp = v[i];
				}}
		}
		if(ind<0){return log(-1.0);}else{
				return v[ind];
		}
}	   


void getFreq(double* Z15, double* d, int* clus, double* freq, double th){
	int ind;
	
	for(ind=0; ind<N; ind++){
		clus[ind] = (int)cblas_idamax(K, Z15+ind, N);
		if(d[ind]<th){clus[ind]=-1;}
	}
	cblas_dgemv(CblasColMajor, CblasTrans, N, K, 1.0, Z15, N, uvn, 1, 0.0, freq, 1);
}

void getFreq0(double* ZAB, double* thetaAB, int N, int K, int* clus, double* freq, double th){
	int ind, j;
	for(j=0; j<K; j++){freq[j]=0.0;}
	for(ind=0; ind<N; ind++){
		clus[ind] = (int)cblas_idamax(K, ZAB+ind, N);
			if(ZAB[N*clus[ind]+ind]/thetaAB[clus[ind]]<th){clus[ind]=-1;}
			if(clus[ind]>(-1)){freq[clus[ind]]++;}
	}
}

void getAVar(double* ZAB, double* dose, int* clus, int N, int K){ 
	int i;
	cblas_dgemv(CblasColMajor, CblasNoTrans, N, K, 1.0, ZAB, N, ab, 1, 0.0, dose, 1);
	for(i=0; i<N; i++){if(clus[i]<0){dose[i]=log(-1.0);}}
}


void getClus(double* Z15, int N, int* clus){
	int ind;
	for(ind=0; ind<N; ind++){
		clus[ind] = (int)cblas_idamax(K, Z15+ind, N);
	}
}
void getClusCN(double* Z15, int N, int* clus){
	int ind;
	double tmp[5];
	for(ind=0; ind<N; ind++){
		tmp[0]=Z15[ind];
		tmp[1]=Z15[ind+N*1]+Z15[ind+N*5];
		tmp[2]=Z15[ind+N*2]+Z15[ind+N*6]+Z15[ind+N*9];
		tmp[3]=Z15[ind+N*3]+Z15[ind+N*7]+Z15[ind+N*10]+Z15[ind+N*12];
		tmp[4]=Z15[ind+N*4]+Z15[ind+N*8]+Z15[ind+N*11]+Z15[ind+N*13]+Z15[ind+N*14];
		clus[ind] = (int)cblas_idamax(5, tmp, 1);
	}
}
void getClusAV(double* Z15, int N, int* clus){
	int ind;
	double tmp[9];
	for(ind=0; ind<N; ind++){
		tmp[0]=                          Z15[ind+N*14];
		tmp[1]=                   Z15[ind+N*12];
		tmp[2]=             Z15[ind+N*9]+Z15[ind+N*13];
		tmp[3]=      Z15[ind+N*5]+Z15[ind+N*10];
		tmp[4]=Z15[ind+N*0]+Z15[ind+N*6]+Z15[ind+N*11];
		tmp[5]=      Z15[ind+N*1]+Z15[ind+N*7];
		tmp[6]=             Z15[ind+N*2]+Z15[ind+N*8];
		tmp[7]=                    Z15[ind+N*3];
		tmp[8]=                           Z15[ind+N*4];
		clus[ind] = 4-(int)cblas_idamax(9, tmp, 1);
	}
}
void getDose(double* Z15, int N, double* dose){
	cblas_dgemv(CblasColMajor, CblasNoTrans, N, K, 1.0, Z15, N, cn, 1, 0.0, dose, 1);
}
void getDoseAV(double* Z15, int N, double* dose){
	cblas_dgemv(CblasColMajor, CblasNoTrans, N, K, 1.0, Z15, N, ab, 1, 0.0, dose, 1);
}



void normalize(double* x, int n){
	cblas_dscal(n, 1.0/cblas_dasum(n, x, 1), x, 1);
}

void getETheta15(double* Theta, double* eTheta15){
	int i, j;
	clear(eTheta15,K);
	double th=0.01;
	double th15[K];
	clear(th15,K);
	for(i=0; i<J; i++){
		for(j=i; j<J; j++){
			int an=a[i]+a[j];
			int bn=b[i]+b[j];
			int k=cs[an+bn*5]; 
			if(i==j){
				th15[k] += th*th;
				eTheta15[k] += Theta[i]*Theta[j];
			}else{			
				th15[k] += th*th*2.0;		  
				eTheta15[k] += Theta[i]*Theta[j]*2.0;
			}  
		}
	}
	//normalize(eTheta15,K);
	for(i=0; i<K; i++){if(eTheta15[i]>th15[i]){eTheta15[i]=1.0;}else{eTheta15[i]=-1.0;}}
}

void getChisq(double* Theta15orig, double* Theta6, double cr, double* chisq){
	
	//vprint(Theta15orig,K);
	//vprint(Theta6,J);
	//printf("cr = %lf chisq = %lf", cr, (*chisq));
	
	double freq[K];
	double efreq[K];
	double Theta[J];
// 2011.09.08: Comment out unused variable Theta21.
	//double Theta21[J*(J+1)/2];
	double Theta15[K];
// 2011.09.08: Comment out unused variable lkhd, lkhd0.
	double n; //, lkhd=.0, lkhd0=.0;
	double th[] = {0.0,0.01,0.03,0.05,0.1};
	double theta15tol[K*5];
	clear(theta15tol,K*5);
	clear(freq,K);
	int itr, i, j, l;
	cblas_dcopy(J, Theta6, 1, Theta, 1);
	cblas_daxpy(K, cr, Theta15orig, 1, freq, 1);
	clear(efreq, K);
// 2011.09.08: Comment out unused logic.
//	for(itr=0; itr<100; itr++){
		clear(Theta15, K);
		l=0;
		for(i=0; i<J; i++){
			for(j=i; j<J; j++){
				int an=a[i]+a[j];
				int bn=b[i]+b[j];
				int k=cs[an+bn*5];
				if(i==j){
					Theta15[k] += Theta[i]*Theta[j];
					for(l=0;l<5;l++){theta15tol[k+l*K] += Power(th[l],2);}
				}else{
					Theta15[k] += Theta[i]*Theta[j]*2.0;
					for(l=0;l<5;l++){theta15tol[k+l*K] += Power(th[l],2)*2.0;}
				}
			}
		}
		normalize(Theta15,K);
//		break;
//		lkhd = 0.0;
//		for(i=0; i<K; i++){if(Theta15[i]>0.0){lkhd += freq[i]*log(Theta15[i]);}}
//		if(itr>2 && fabs(lkhd-lkhd0)<1e-8){break;}else{lkhd0=lkhd;}
//		l=0;
//		for(i=0; i<J; i++){
//			for(j=i; j<J; j++){
//				int an=a[i]+a[j];
//				int bn=b[i]+b[j];
//				int k=cs[an+bn*5];
//				if(Theta15[k]>0.0){
//					if(i==j){
//						Theta21[l++] = Theta[i]*Theta[j]*freq[k]/Theta15[k];
//					}else{
//						Theta21[l++] = Theta[i]*Theta[j]*2.0*freq[k]/Theta15[k];
//					}
//				}else{Theta21[l++]=0.0;}
//			}
//		}
//		l=0;
//		normalize(Theta21, J*(J+1)/2);
//		clear(Theta,J);
//		for(i=0; i<J; i++){
//			for(j=i; j<J; j++){
//				//int an=a[i]+a[j];
//				//int bn=b[i]+b[j];
//				//int k=cs[an+bn*5];
//				if(i==j){
//					Theta[i] += Theta21[l++];
//				}else{
//					Theta[i] += Theta21[l]/2.0;
//					Theta[j] += Theta21[l++]/2.0;
//				}
//			}
//		}
//		normalize(Theta, J);
//	}

	for(itr=1;itr<2;itr++){
		int df=0;
		(*chisq)=0.0;
		n = cr;
		for(i=0; i<J; i++){if(Theta[i]>th[itr]){df--;}}
		for(i=0; i<K; i++){if(Theta15[i]>theta15tol[i+itr*K]){df++;}}
		for(i=0; i<K; i++){
			if(Theta15[i] > theta15tol[i+itr*K]){
				(*chisq) += Power(Theta15[i]*n-freq[i],2)/Theta15[i]/n;
			}
		}
		(*chisq) = q_chisq((*chisq), df);
	}
}





ldiv_t ncol(char* fn, int n){
	FILE *fp;
	if((fp = fopen(fn,"rb"))==NULL){printf("%s no such file!\n", fn);exit(EXIT_FAILURE);}
	fseek(fp,0,SEEK_END);
	long sz = ftell(fp);
	//printf("%s: %ld\n", fn, sz);
	fclose(fp);
	return ldiv(sz, (long)(8*n));
}


int ncol_int(char* fn, int n){
	FILE *fp;
	if((fp = fopen(fn,"rb"))==NULL){printf("%s no such file!\n", fn);exit(EXIT_FAILURE);}
	fseek(fp,0,SEEK_END);
	long sz = ftell(fp);
	//printf("%s: %ld\n", fn, sz/(long)n/4);
	fclose(fp);
	return (int)(sz/4/n);
}



double getEP(int i, int j){
	if(cs[i]>=0 && cs[j]>=0){
//printf("%d %d %lf %lf\n",cs[i],cs[j],dkls[cs[i]*K+cs[j]],dkls[cs[j]*K+cs[i]]);
		if(dkls[cs[i]*K+cs[j]]>dkls[cs[j]*K+cs[i]]){
			return dkls[cs[i]*K+cs[j]];
		}else{
			return dkls[cs[i]+cs[j]*K];
		}
	}else{return 0.0;}
}

int chkEP(double* Mu, double* Sigma, double* Theta15){
	int i,j,m,k;
	int res=0;
	clear(dkls,K*K);
	for(j=0; j<K-1; j++){
		for(m=j+1; m<K; m++){
			if(Theta15[j]>0.0&&Theta15[m]>0.0){
				dkls[j*K+m] = EP(Mu+j*2, Mu+m*2, Sigma+j*4);
				dkls[m*K+j] = EP(Mu+j*2, Mu+m*2, Sigma+m*4);
			}
		}
	}
	//if(max(dkls,K*K)<0.1){res=0;}else{res=1;}
	int gn0[] = {1,5,6};
	int gaa[] = {1,2,3,4};          // 20 | 
	int gbb[] = {5,10,15,20};       // 15 | 16
	//int gab[] = {6,7,8,11,12,16}; // 10 | 11 12
	int gaba[] = {6,7,8};           //  5 |  6  7  8
	int gabb[] = {6,11,16};         // -----------------
	int gabc[] = {6,7,12,11,6};     //  0 |  1  2  3  4
	double th[] = {0.01,0.02,0.03};
	
	for(i=0;i<3;i++){
		if(getEP(0,gn0[i])>0.005){res++;}
	}
	for(j=0; j<4; j++){
		for(k=0; k<3; k++){
			if(getEP(gaa[j],gaba[k])>0.001){res++;}
		}
	}
	for(j=0; j<4; j++){
		for(k=0; k<3; k++){
			if(getEP(gbb[j],gabb[k])>0.001){res++;}
		}
	}
	if(getEP(11,16)>0.0001){res++;} 
        if(getEP(7,8)>0.0001){res++;}
	//for(j=0; j<5; j++){
	//	for(k=j+1; k<6; k++){
	//		if(getEP(gab[j],gab[k])>0.0005){res++;}
	//	}
	//}
//printf("ep=%d\n",res);
	for(j=0; j<3; j++){
		if(getEP(gaa[j],gaa[j+1])>th[j]){res++;}
	}
//printf("ep=%d\n",res);

	for(j=0; j<3; j++){
		if(getEP(gbb[j],gbb[j+1])>th[j]){res++;}
	}
	for(j=0; j<4; j++){
		if(getEP(gabc[j],gabc[j+1])>0.00005){res++;}
	}
	//printf("ep=%d\n",res);
	return res;
}

double getMaha(double* Mu, double* Mu0){
	double maha = 0.0;
	int M=K*2;
	double tmp[M];
	cblas_dcopy(M, Mu, 1, tmp, 1);
	cblas_daxpy(M, -1.0, Mu0, 1, tmp, 1);
	int i,j;
	for(i=0; i<M; i++){
		for(j=i; j<M; j++){
			if(i==j){
				maha += Sinv[i*M+j]*tmp[i]*tmp[j];
			}else{
				maha += 2.0*Sinv[i*M+j]*tmp[i]*tmp[j];
			}
		}
	}
	return maha;
}

double mdist(double m1, double m2, double s1, double s2){
	double tmp=Power(m1-m2,2);
	return tmp/s1+tmp/s2;
}

int chklattice(double* Mu, double* Sigma, double* Theta15){
	int i,j,a,b,c,d,flag=0;
	double k = Mu[4]/Mu[19];
//printf("k=%lf\n",k);
	for(i=0; i<4; i++){
		for(j=0; j<4; j++){
			a = cs[j*5+i];            // b--d
			b = cs[(j+1)*5+i];        // |  |
			c = cs[j*5+i+1];          // a--c
			d = cs[(j+1)*5+i+1];
			if(a>=0){if(Theta15[a]>0.0){
				if(b>=0){if(Theta15[b]>0.0){
					if(Mu[a*2+1]>Mu[b*2+1]){flag++;}
					if(mdist(Mu[a*2],Mu[b*2],Sigma[a*4],Sigma[b*4])>mdist(Mu[a*2+1],Mu[b*2+1],Sigma[a*4+3],Sigma[b*4+3])){flag++;}
					if(fabs(Mu[a*2]-Mu[b*2])>k*fabs(Mu[a*2+1]-Mu[b*2+1])){flag++;}
				}};
				if(c>=0){if(Theta15[c]>0.0){
					if(Mu[a*2]>Mu[c*2]){flag++;}
					if(mdist(Mu[a*2+1],Mu[c*2+1],Sigma[a*4+3],Sigma[c*4+3])>mdist(Mu[a*2],Mu[c*2],Sigma[a*4],Sigma[c*4])){flag++;}
					if(k*fabs(Mu[a*2+1]-Mu[c*2+1])>fabs(Mu[a*2]-Mu[c*2])){flag++;}
				}};
				if(d>=0){if(Theta15[d]>0.0){if(Mu[a*2]>Mu[d*2] || Mu[a*2+1]>Mu[d*2+1]){flag++;}}};
			}}
		}
	}
	return flag;
}

int chkABtheta(double *Theta){
// 2011.09.08: Fix operand & -> && .
	//if(Theta[1]>0.01&Theta[4]>0.01&Theta[0]<0.01&Theta[2]<0.01&Theta[3]<0.01&Theta[5]<0.01){
	if(Theta[1]>0.01 && Theta[4]>0.01 && Theta[0]<0.01 && Theta[2]<0.01 && Theta[3]<0.01 && Theta[5]<0.01){
		return 1;
// 2011.09.08: Fix operand & -> && .
	//}else if(Theta[2]>0.01&Theta[4]>0.01&Theta[0]<0.01&Theta[1]<0.01&Theta[3]<0.01&Theta[5]<0.01){
	}else if(Theta[2]>0.01 && Theta[4]>0.01 && Theta[0]<0.01 && Theta[1]<0.01 && Theta[3]<0.01 && Theta[5]<0.01){
		return 1;
	}
	return 0;
}

int chktheta(double* Alpha, double th){
// 2011.09.08: Comment out unused variable i.
	//int i;
	int n=0;
	double Theta[J];
	cblas_dcopy(J, Alpha, 1, Theta, 1);
	normalize(Theta, J);
	if(Theta[0]>th){n++;}
	if(Theta[1]>th || Theta[2]>th){n++;}
	if(Theta[3]>th || Theta[4]>th || Theta[5]>th){n++;}
	
	if(Theta[1]+Theta[2]>(1.0-th) || Theta[2]+Theta[3]>(1.0-th) || Theta[1]+Theta[5]>(1.0-th) || Theta[3]+Theta[5]>(1.0-th) || Theta[4]+Theta[5]>(1.0-th) || Theta[3]+Theta[4]>(1.0-th) || n<2){return 1;}
	return 0;
}


void settheta(double* Theta, double q1, double q2){
	int i;
	double pa=q1/(q1+q2);
	double pb=1.0-pa;
	double prob[]={1.0,2.0*pa,2.0*pb,3.0*pa*pa,3.0*pb*pa*2.0,3.0*pb*pb};
	for(i=0; i<J; i++){Theta[i]=prob[i]*alpha[i]/alpha0;}
}




void FwriteTextInt(int* x, int N, FILE* fp){
	int i;
	if(fp!=NULL){
		if(x==NULL){
			for(i=0; i<N-1; i++){fprintf(fp,"NA\t");} 
			fprintf(fp,"NA\n");
		}else{
			for(i=0; i<N-1; i++){fprintf(fp,"%d\t",x[i]);} 
			fprintf(fp,"%d\n",x[N-1]);
		}
	}
}
void FwriteText(double* x, int N, FILE* fp){
	int i;
	if(fp!=NULL){
		if(x==NULL){
			for(i=0; i<N-1; i++){fprintf(fp,"NA\t");} 
			fprintf(fp,"NA\n");
		}else{
			for(i=0; i<N-1; i++){fprintf(fp,"%.3lf\t",x[i]);} 
			fprintf(fp,"%.3lf\n",x[N-1]);
		}
	}
}
void FwriteInt(int* x, int N, FILE* fp){
	int i;
	if(fp!=NULL){
		if(x==NULL){
			int tmp = 99;
			for(i=0; i<N; i++){fwrite(&tmp, sizeof(int), 1 ,fp);} 
		}else{
			fwrite(x, sizeof(int), N ,fp);
		}
	}
}
void Fwrite(double* x, int N, FILE* fp){
	int i;
	if(fp!=NULL){
		if(x==NULL){
			double tmp = log(-1.0);
			for(i=0; i<N; i++){fwrite(&tmp, sizeof(double), 1 ,fp);} 
		}else{
			fwrite(x, sizeof(double), N ,fp);
		}
	}
}




void printVersion(){
	char version[]="1.0.11.08.21";
	printf("\n");
	printf("PlatinumCNV  %s  -- Bayesian Gaussian Mixture Model for CNP Genotyping \n",version);
	printf("(c) 2011 Natsuhiko Kumasaka.  All rights reserved.\n");
	printf("\n");
}






